# Configuration Store Project Documentation

# Guidance for Submitting Issues

Here are the guidelines for submitting issues to the configuration-store repository:

- If you have an issue with configuration-store then please file an issue at github.com/armmbed/configuration-store.git
- The issue should be filed with a stand-alone testcase or sample application that only depends on configuration-store and shows the fault on the target platform. 
- The issue should include the following information under separate SUMMARY and DETAILS headings:

```
    
    SUMMARY
    =======
    APPLCIATION/Library NAME:   <e.g. configuration_store, example3, myappname> 
    OS VERSION:                 <e.g. MBEDOSv3>
    TARGET:                     <e.g. k64f>
    TOOLCHAIN:                  <e.g. GCC_ARM, ARM>
    DESCRIPTION:                <e.g. a 1-line summary description of the problem >
    MODULE DEPENDENCIES:        <e.g. the version of the modules used to build the application, output from yotta ls, etc>
    
    DETAILS
    =======
    <step by step guide about how to build and test the provided resources so as to reproduce the problem. 
    
    CODE
    ====
    <details of supplied code sample showing problem>
```



